# NASM - The Netwide Assembler

version 2.16.03

## Index

- `!` operator
  3.5.12
- `!=` operator
  3.5.5
- `$`, current address
  3.5
- `$`, prefix
  3.1, 3.4.1
- `$$` token
  3.5, 8.9.3
- `%,`
  4.2.12
- `%[`
  4.2.3
- `%[]`
  4.1.6
- `%` operator
  3.5.11
- `%` prefix to `DB` lists
  3.2.1
- `%!`
  4.1.8, 4.13.2
- `%$` and `%$$` prefixes
  4.9.2
- `%%` operator
  3.5.11, 4.5.2
- `%*?`
  4.2.6
- `%*??`
  4.2.6
- `%+`
  4.1.6, 4.2.4
- `%+1` and `%-1` syntax
  4.5.10
- `%?`
  4.2.5
- `%??`
  4.2.5
- `%00`
  4.5.7
- `%0` parameter count
  4.5.5, 4.5.6
- `%abs()`
  4.4.1
- `%arg`
  4.10.1
- `%assign`
  4.2.8, 4.4.4
- `%clear`
  4.13.3, 5
- `%cond()`
  4.4.2
- `%count()`
  4.4.3
- `%defalias`
  4.2.11
- `%define`
  2.1.20, 4.2.1
- `%defstr`
  4.2.9, 4.4.10
- `%deftok`
  4.2.10, 4.4.14
- `%depend`
  4.8.3
- `%elif`
  4.6, 4.6.4
- `%elifctx`
  4.6.3
- `%elifdef`
  4.6.1
- `%elifempty`
  4.6.8
- `%elifenv`
  4.6.9
- `%elifid`
  4.6.6
- `%elifidn`
  4.6.5
- `%elifidni`
  4.6.5
- `%elifmacro`
  4.6.2
- `%elifn`
  4.6, 4.6.4
- `%elifnctx`
  4.6.3
- `%elifndef`
  4.6.1
- `%elifnempty`
  4.6.8
- `%elifnenv`
  4.6.9
- `%elifnid`
  4.6.6
- `%elifnidn`
  4.6.5
- `%elifnidni`
  4.6.5
- `%elifnmacro`
  4.6.2
- `%elifnnum`
  4.6.6
- `%elifnstr`
  4.6.6
- `%elifntoken`
  4.6.7
- `%elifnum`
  4.6.6
- `%elifstr`
  4.6.6
- `%eliftoken`
  4.6.7
- `%else`
  4.6
- `%endrep`
  4.7
- `%error`
  4.11
- `%eval()`
  4.2.8, 4.4.4, 4.4.5
- `%exitrep`
  4.7
- `%fatal`
  4.11
- `%hex()`
  4.4.5
- `%iassign`
  4.2.8
- `%idefalias`
  4.2.11
- `%idefine`
  4.2.1
- `%idefstr`
  4.2.9
- `%ideftok`
  4.2.10
- `%if`
  4.1.4, 4.4.6, 4.6, 4.6.4
- `%ifctx`
  4.6.3, 4.9.6
- `%ifdef`
  4.6.1
- `%ifempty`
  4.6.8
- `%ifenv`
  4.6.9
- `%ifid`
  4.6.6
- `%ifidn`
  4.6.5
- `%ifidni`
  4.6.5
- `%ifmacro`
  4.6.2
- `%ifn`
  4.6, 4.6.4
- `%ifnctx`
  4.6.3
- `%ifndef`
  4.6.1
- `%ifnempty`
  4.6.8
- `%ifnenv`
  4.6.9
- `%ifnid`
  4.6.6
- `%ifnidn`
  4.6.5
- `%ifnidni`
  4.6.5
- `%ifnmacro`
  4.6.2
- `%ifnnum`
  4.6.6
- `%ifnstr`
  4.6.6
- `%ifntoken`
  4.6.7
- `%ifnum`
  4.6.6
- `%ifstr`
  4.6.6
- `%iftoken`
  4.6.7
- `%imacro`
  4.1.4, 4.5
- `%include`
  2.1.18, 2.1.19, 4.8.1
- `%is()`
  4.4.6
- `%ixdefine`
  4.2.2
- `%line`
  2.1.33, 4.1.3, 4.1.8, 4.13.1
- `%local`
  4.10.3
- `%macro`
  4.1.4, 4.5
- `%map()`
  4.4.7
- `%num()`
  4.4.8
- `%pathsearch`
  2.1.18, 4.8.2
- `%pop`
  4.9, 4.9.1
- `%pragma`
  4.12
- `%push`
  4.9, 4.9.1
- `%rep`
  3.2.5, 4.1.4, 4.7
- `%repl`
  4.9.5
- `%rotate`
  4.5.8
- `%sel()`
  4.4.2, 4.4.9
- `%stacksize`
  4.10.2
- `%str()`
  4.2.9, 4.4.10
- `%strcat`
  4.3.1, 4.4.11
- `%strcat()`
  4.4.11
- `%strlen`
  4.3.2, 4.4.12
- `%strlen()`
  4.4.12
- `%substr`
  4.3.3, 4.4.13
- `%substr()`
  4.4.13
- `%tok()`
  4.2.10, 4.4.14
- `%undef`
  2.1.21, 4.2.7
- `%unimacro`
  4.5.12
- `%unmacro`
  4.5.12
- `%use`
  4.8.4, 6
- `%warning`
  4.11
- `%xdefine`
  4.2.2
- `&` operator
  3.5.8
- `&&` operator
  3.5.4
- `*` operator
  3.5.11
- `+` modifier
  4.5.3
- `+` operator, binary
  3.5.10
- `+` operator, unary
  3.5.12
- `-` operator, binary
  3.5.10
- `-` operator, unary
  3.5.12
- `--before`
  2.1.30
- `--(g|l)postfix`
  2.1.28
- `--(g|l)prefix`
  2.1.28
- `--keep-all`
  2.1.32
- `--limit-X`
  2.1.31
- `--no-line`
  2.1.33, 4.13.1
- `--pragma`
  2.1.29
- `--reproducible`
  2.1.34
- `--v`
  2.1.27
- `-a` option
  2.1.23, B.2.3
- `-b`
  B.2
- `-D` option
  2.1.20
- `-d` option
  2.1.20
- `-E` option
  2.1.22
- `-e` option
  2.1.22, B.2.4
- `-F` option
  2.1.13
- `-f` option
  2.1.2, 8
- `-g` option
  2.1.14
- `-h`
  B.2
- `-I` option
  2.1.18
- `-i` option
  2.1.18, B.2.3
- `-k`
  B.2.4
- `-L` option
  2.1.4
- `-l` option
  2.1.3
- `-M` option
  2.1.5
- `-MD` option
  2.1.8
- `-MF` option
  2.1.7
- `-MG` option
  2.1.6
- `-MP` option
  2.1.11
- `-MQ` option
  2.1.10
- `-MT` option
  2.1.9
- `-MW` option
  2.1.12
- `-O` option
  2.1.24
- `-o` option
  2.1.1, B.2.1
- `-P` option
  2.1.19
- `-p` option
  2.1.19, 4.8.1
- `-r`
  B.2
- `-s` option
  2.1.17, B.2.2
- `-soname`
  10.2.6
- `-t`
  2.1.25
- `-U` option
  2.1.21
- `-u` option
  2.1.21, B.2
- `-v` option
  2.1.27
- `-W` option
  2.1.26
- `-w` option
  2.1.26
- `-Werror` option
  2.1.26
- `-Wno-error` option
  2.1.26
- `-X` option
  2.1.15
- `-Z` option
  2.1.16
- `..@` symbol prefix
  3.9, 4.5.2
- `..got`
  8.9.3
- `..gotoff`
  8.9.3
- `..gotpc`
  8.9.3
- `..gottpoff`
  8.9.4
- `..plt`
  8.9.3
- `..start`
  8.4.6, 9.1.1
- `..sym`
  8.9.3
- `..tlsie`
  8.9.4
- `.bss`
  8.9.2, 8.10, 8.11, 8.12
- `.COM`
  8.1, 9.2
- `.comment`
  8.9.2
- `.data`
  8.9.2, 8.10, 8.11, 8.12
- `.drectve`
  8.5.1
- `.EXE`
  8.4, 9.1
- `.lbss`
  8.9.2
- `.ldata`
  8.9.2
- `.lrodata`
  8.9.2
- `.nolist`
  4.5.11
- `.obj`
  9.1
- `.rodata`
  8.9.2
- `.SYS`
  8.1, 9.3
- `.tbss`
  8.9.2
- `.tdata`
  8.9.2
- `.text`
  8.9.2, 8.10, 8.11, 8.12
- `/` operator
  3.5.11
- `//` operator
  3.5.11
- `<` operator
  3.5.5
- `<<` operator
  3.5.9
- `<<<` operator
  3.5.9
- `<=` operator
  3.5.5
- `<=>` operator
  3.5.5
- `<=>` operator
  3.5.5
- `<>` operator
  3.5.5
- `=` operator
  3.5.5
- `==` operator
  3.5.5
- `>` operator
  3.5.5
- `>=` operator
  3.5.5
- `>>` operator
  3.5.9
- `>>>` operator
  3.5.9
- `?`, data syntax
  3.2.1, 3.2.2
- `?`, operator
  3.5.1
- \c{section
  8.1.2
- `^` operator
  3.5.7
- `^^` operator
  3.5.3
- `__?ALIGNMODE?__`
  6.2
- `__?bfloat16?__`
  3.4.6
- `__?BITS?__`
  5.3
- `__?DATE?__`
  5.6
- `__?DATE_NUM?__`
  5.6
- `__?DEBUG_FORMAT?__`
  5.5
- `__?FILE?__`
  5.2
- `__?FLOAT?__`
  7.12
- `__?FLOAT_DAZ?__`
  7.12
- `__?FLOAT_ROUND?__`
  7.12
- `__?float8?__`
  3.4.6
- `__?float16?__`
  3.4.6
- `__?float32?__`
  3.4.6
- `__?float64?__`
  3.4.6
- `__?float80e?__`
  3.4.6
- `__?float80m?__`
  3.4.6
- `__?float128h?__`
  3.4.6
- `__?float128l?__`
  3.4.6
- `__?Infinity?__`
  3.4.6
- `__?LINE?__`
  5.2
- `__?NaN?__`
  3.4.6
- `__?NASM_MAJOR?__`
  5.1
- `__?NASM_MINOR?__`
  5.1
- `__?NASM_PATCHLEVEL?__`
  5.1
- `__?NASM_SNAPSHOT?__`
  5.1
- `__?NASM_SUBMINOR?__`
  5.1
- `__?NASM_VER?__`
  5.1.2
- `__?NASM_VERSION_ID?__`
  5.1.1
- `__?OUTPUT_FORMAT?__`
  5.4
- `__?PASS?__`
  5.8
- `__?QNaN?__`
  3.4.6
- `__?SECT?__`
  7.3.1, 7.4
- `__?SNaN?__`
  3.4.6
- `__?TIME?__`
  5.6
- `__?TIME_NUM?__`
  5.6
- `__?USE_*?__`
  5.7
- `__?UTC_DATE?__`
  5.6
- `__?UTC_DATE_NUM?__`
  5.6
- `__?UTC_TIME?__`
  5.6
- `__?UTC_TIME_NUM?__`
  5.6
- `__?utf16?__`
  3.4.5
- `__?utf16be?__`
  3.4.5
- `__?utf16le?__`
  3.4.5
- `__?utf32?__`
  3.4.5
- `__?utf32be?__`
  3.4.5
- `__?utf32le?__`
  3.4.5
- `__NASMDEFSEG`
  8.4
- `_DATA`
  9.4.2
- `_GLOBAL_OFFSET_TABLE_`
  8.9.3
- `_TEXT`
  9.4.2
- `nowait'
  2.2.6
- `|` operator
  3.5.6
- `||` operator
  3.5.2
- `~` operator
  3.5.12
- 1's complement
  3.5.12
- 2's complement
  3.5.12
- 16-bit mode, versus 32-bit mode
  7.1
- 64-bit displacement
  12.2
- 64-bit immediate
  12.2
- `a.out`, BSD version
  8.11
- `a.out`, Linux version
  8.10
- `A16`
  3.1, 11.3
- `A32`
  3.1, 11.3
- `A64`
  3.1, 11.3
- `a86`
  2.2, 2.2.2, 2.2.6
- `ABS`
  3.3, 7.2.1
- `ABSOLUTE`
  7.4, 8.4.1
- addition
  3.5.10
- address-size prefixes
  3.1
- addressing, mixed-size
  11.2
- algebra
  3.3
- `ALIGN`
  5.10.1, 6.2, 8.1.2, 8.4.1
- `ALIGN`, smart
  6.2
- align, elf attribute
  8.9.2
- `ALIGNB`
  5.10.1
- alignment
  5.10
- alignment, in `bin` sections
  8.1.2
- alignment, in ELF sections
  8.9.2
- alignment, in `obj` sections
  8.4.1
- alignment, in `win32` sections
  8.5.1
- alignment, of ELF common variables
  8.9.7
- `ALIGNMODE`
  6.2
- `ALINK`
  9.1.1
- `alink.sourceforge.net`
  9.1.1
- `alloc`
  8.9.2
- alternate register names
  6.1
- `altreg`
  6.1
- ambiguity
  2.2.3
- `aout`
  8.10
- `aoutb`
  8.11, 10.2
- `arg`
  9.4.5, 10.1.4
- `as86`
  8.12
- assembler directives
  7
- assembly-time options
  2.1.20
- `ASSUME`
  2.2.4
- `AT`
  5.9.2
- `auto-sync`
  B.2.3
- baddb
  3.2.1
- `bf16`
  6.3
- `bfloat16`
  3.4.6
- `bin` output format
  2.1.2, 8.1
- bin, multisection
  8.1.3
- binary
  3.4.1
- binary files
  3.2.3
- bit shift
  3.5.9
- `BITS`
  7.1, 8.1
- bitwise AND
  3.5.8
- bitwise OR
  3.5.6
- bitwise XOR
  3.5.7
- block IFs
  4.9.6
- `BND`
  7.2.2
- boolean, AND
  3.5.4
- boolean, OR
  3.5.2
- boolean, XOR
  3.5.3
- boot loader
  8.1
- boot sector
  13.1.3
- Borland, Pascal
  9.5
- Borland, Win32 compilers
  8.4
- braces, after `%` sign
  4.5.9
- braces, around macro parameters
  4.5
- BSD
  10.2
- bug tracker
  E.2
- bugs
  E.2
- `BYTE`
  13.1.1
- C calling convention
  9.4.3, 10.1.2
- C symbol names
  9.4.1
- `c16.mac`
  9.4.5, 9.5.3
- `c32.mac`
  10.1.4
- `CALL FAR`
  3.6
- case sensitivity
  2.2.1, 4.2.1, 4.2.2, 4.2.8, 4.5, 4.6.5, 8.4.3
- changing sections
  7.3
- character constant
  3.2.1, 3.4.3
- character strings
  3.4.2
- circular references
  4.2.1
- `CLASS`
  8.4.1
- CodeView debugging format
  8.5.3
- `coff`
  8.7
- colon
  3.1
- comdat section, in win32
  8.5.1
- comdat symbol, in win32
  8.5.1
- comdat, win32 attribute
  8.5.1
- comma
  4.5.4
- command-line
  2.1, 8
- commas in macro parameters
  4.5.3
- comment
  3.1, 4.1.2
- comment, ending in `\`
  4.1.2
- comment, removal
  4.1.2
- comment, syntax
  4.1.2
- `COMMON`
  7.8, 8.4.1
- `COMMON`, ELF extensions to
  8.9.7
- `COMMON`, `obj` extensions to
  8.4.8
- Common Object File Format
  8.7
- common variables
  7.8
- common variables, alignment in ELF
  8.9.7
- common variables, element size
  8.4.8
- `comp.os.msdos.programmer`
  9.3
- comparison operators
  3.5.5
- concatenating macro parameters
  4.5.9
- concatenating strings
  4.3.1
- concatenation
  4.1.6
- condition codes as macro parameters
  4.5.10
- conditional assembly
  4.1.4, 4.6
- conditional comma operator
  4.2.12
- conditional jumps
  13.1.2
- conditional-return macro
  4.5.10
- constants
  3.4
- context fall-through lookup
  4.9.4
- context stack
  4.9, 4.9.6
- context-local labels
  4.1.8, 4.9.2
- context-local single-line macros
  4.9.3
- continuation line
  4.1.1
- continuation lines
  4.1.2
- counting macro parameters
  4.5.6
- `CPU`
  7.11
- `CPUID`
  3.4.3
- creating contexts
  4.9.1
- critical expression
  3.2.2, 3.8, 4.2.8, 4.4.4, 7.4, A
- `cv8`
  8.5.3
- daily development snapshots
  E.1
- `data`
  8.9.5
- data structure
  9.4.4, 10.1.3
- `DB`
  3.2, 3.2.1, 3.4.4, 3.4.6
- `dbg`
  8.13
- `DD`
  3.2, 3.2.1, 3.4.4, 3.4.6
- debug information
  2.1.14
- debug information format
  2.1.13
- decimal
  3.4.1
- declaring structures
  5.9.1
- `DEFAULT`
  7.2
- `default`
  8.9.5
- default macro parameters
  4.5.5
- default name
  8
- default-`WRT` mechanism
  8.4.7
- defining sections
  7.3
- design goals
  2.2.2
- detokenization
  4.1.4, 4.1.5, 4.1.8
- DevPac
  3.9
- directives
  4.1.5
- disabling listing expansion
  4.5.11
- division
  3.5.11
- division, signed
  3.5.11
- division, unsigned
  3.5.11
- DJGPP
  8.7, 10
- `djlink`
  9.1.1
- DLL symbols, exporting
  8.4.5
- DLL symbols, importing
  8.4.4
- `DO`
  3.2, 3.2.1, 3.4.4, 3.4.6
- DOS
  2.1.16, 2.1.17
- `DQ`
  3.2, 3.2.1, 3.4.4, 3.4.6
- `DT`
  3.2, 3.2.1, 3.4.4, 3.4.6
- `DUP`
  3.2.1, 3.2.2, 3.2.5
- `DW`
  3.2, 3.2.1, 3.4.4, 3.4.6
- `DWORD`
  3.1
- `DY`
  3.2, 3.2.1, 3.4.4
- `DZ`
  3.2, 3.2.1
- effective addresses
  3.1, 3.3
- element size, in common variables
  8.4.8
- ELF
  8.9
- ELF, 16-bit code
  8.9.8
- ELF, debug formats
  8.9.9
- ELF, shared libraries
  8.9.5
- `elf32`
  8.9
- `elf64`
  8.9
- `elfx32`
  8.9
- `endproc`
  9.4.5, 10.1.4
- `ENDSTRUC`
  5.9.1, 7.4
- environment
  2.1.35
- `EQU`
  3.2, 3.2.4
- error messages
  2.1.16, 2.1.17
- error reporting format
  2.1.15
- escape sequences
  3.4.2
- `EVEN`
  5.10.1
- exact matches
  4.5.12
- `EXE_begin`
  9.1.2
- `EXE_end`
  9.1.2
- `EXE_stack`
  9.1.2
- `EXE2BIN`
  9.2.2
- `exebin.mac`
  9.1.2
- `exec`
  8.9.2
- Executable and Linkable Format
  8.9
- `EXPORT`
  8.4.5
- exporting symbols
  7.7
- expressions
  2.1.22, 3.5
- extension
  2.1.1, 8
- `EXTERN`
  7.5
- `EXTERN`, `elf` extensions to
  8.9.6
- `EXTERN`, `obj` extensions to
  8.4.7
- extracting substrings
  4.3.3
- far call
  2.2.5
- far common variables
  8.4.8
- far pointer
  3.6
- `FARCODE`
  9.4.5, 9.5.3
- `fini_array`
  8.9.2
- `FLAT`
  8.4.1
- flat memory model
  10
- flat-form binary
  8.1
- `FLOAT`
  7.12
- floating-point, constants
  3.4.6, 7.12
- floating-point, packed BCD constants
  3.4.7
- floating-point
  2.2.6, 3.1, 3.2.1, 3.4.6
- `follows=`
  8.1.3
- format-specific directives
  7
- `fp`
  6.3
- frame pointer
  9.4.3, 9.5.1, 10.1.2
- FreeBSD
  8.11, 10.2
- FreeLink
  9.1.1
- `ftp.simtel.net`
  9.1.1
- `function`
  8.9.5
- functions, C calling convention
  9.4.3, 10.1.2
- functions, `PASCAL` calling convention
  9.5.1
- `(G|L)POSTFIX`
  7.10
- `(G|L)PREFIX`
  7.10
- `git`
  D.2
- `GLOBAL`
  7.7
- `GLOBAL`, `aoutb` extensions to
  8.9.5
- `GLOBAL`, ELF extensions to
  8.9.5
- global offset table
  10.2
- `GLOBAL`, `rdf` extensions to
- GOT
  8.9.3, 10.2
- `GOT` relocations
  10.2.3
- `GOTOFF` relocations
  10.2.2
- `GOTPC` relocations
  10.2.1
- graphics
  3.2.3
- greedy macro parameters
  4.5.3
- `GROUP`
  8.4.2
- groups
  3.6
- here token
  3.5
- hexadecimal
  3.4.1
- `hidden`
  8.9.5
- hybrid syntaxes
  2.2.2
- `IEND`
  5.9.2
- `ifunc`
  6.4
- `ilog2()`
  6.4.1
- `ilog2c()`
  6.4.1
- `ilog2cw()`
  6.4.1
- `ilog2e()`
  6.4.1
- `ilog2f()`
  6.4.1
- `ilog2fw()`
  6.4.1
- `ilog2w()`
  6.4.1
- `IMPORT`
  8.4.4
- import library
  8.4.4
- importing symbols
  7.5
- importing symbols, unconditionally
  7.6
- `INCBIN`
  3.2, 3.2.3, 3.4.4
- include search path
  2.1.18
- including other files
  4.8.1
- inefficient code
  13.1.1
- infinite loop
  3.5
- infinity
  3.4.6
- informational section
  8.5.1
- `init_array`
  8.9.2
- inline expansions
  4.1.4, 4.1.5, 4.1.6
- instances of structures
  5.9.2
- instruction list
  F
- integer functions
  6.4
- integer logarithms
  6.4.1
- intel hex
  8.2
- Intel number formats
  3.4.6
- `internal`
  8.9.5
- `ISTRUC`
  5.9.2
- iterating over macro parameters
  4.5.8
- `ith`
  8.2
- `Jcc NEAR`
  13.1.2
- `JMP DWORD`
  11.1
- jumps, mixed-size
  11.1
- label preceding macro
  4.5.7
- label prefix
  3.9
- label-orphan
  3.1
- last
  4.5.4
- `ld86`
  8.12
- license
  1.1.1
- linker, free
  9.1.1
- Linux, `a.out`
  8.10
- Linux, `as86`
  8.12
- Linux, ELF
  8.9
- list of warning classes
  A
- listing file
  2.1.3
- little-endian
  3.4.3
- local labels
  3.9
- Mach, object file format
  8.8
- Mach-O, object file format
  8.8
- `macho32`
  8.8
- `macho64`
  8.8
- MacOS X
  8.8
- macro indirection
  4.1.6, 4.2.3
- macro library
  2.1.18
- macro parameters range
  4.5.4
- macro processor
  4
- macro-local labels
  4.1.6, 4.5.2
- macros
  3.2.5
- makefile dependencies
  2.1.5, 2.1.6
- map files
  8.1.4
- MASM
  2.2, 3.2.1, 3.2.5, 6.5, 8.4
- masm compatibility
  6.5
- MASM, `DB` syntax
  3.2.1, 3.2.2
- memory models
  2.2.5, 9.4.2
- memory operand
  3.1
- memory references
  2.2.2, 3.3
- `merge`
  8.9.2
- Microsoft OMF
  8.4
- minifloat
  3.4.6
- Minix
  8.12
- `misc` subdirectory
  9.1.2, 9.4.5, 10.1.4
- mixed-language program
  9.4
- mixed-size addressing
  11.2
- mixed-size instruction
  11.1
- modulo
  3.5.11
- modulo, signed
  3.5.11
- modulo, unsigned
  3.5.11
- motorola s-records
  8.3
- MS-DOS
  8.1
- MS-DOS device drivers
  9.3
- multi-line macro
  4.1.4, 4.1.6
- multi-line macro expansion
  4.1.7
- multi-line macros
  4.1.7, 4.5, A
- multipass optimization
  2.1.24
- multiple section names
  8.1
- multiplication
  3.5.11
- multiplier
  8.9.2
- `multipush` macro
  4.5.8
- multisection
  8.1.3
- NaN
  3.4.6
- `nasm -h`
  2.1.2
- NASM version
- NASM version, history
  C
- NASM version, ID macro
  5.1.1
- NASM version, macros
  5.1
- NASM version, string macro
  5.1.2
- `nasm-devel`
  E.1.2
- `nasm.out`
  2.1.1
- `NASMENV`
  2.1.35
- ndisasm
  B
- near call
  2.2.5
- near common variables
  8.4.8
- negation, arithmetic
  3.5.12
- negation, bitwise
  3.5.12
- negation, bitwise
  3.5.12
- negation, boolean
  3.5.12
- negation, boolean
  3.5.12
- NetBSD
  8.11, 10.2
- new releases
  E.1
- `no_dead_strip`
  8.8.4
- `noalloc`
  8.9.2
- `nobits`
  8.1.3, 8.9.2
- `NOBND`
  7.2.2
- `noexec`
  8.9.2
- `note`
  8.9.2
- `nowrite`
  8.9.2
- NSIS
  D.1
- Nullsoft Scriptable Installer
  D.1
- numeric constants
  3.2.1, 3.4.1
- `O16`
  3.1, 11.3
- `O32`
  3.1, 11.3
- `O64`
  3.1
- `obj`
  8.4
- `object`
  8.9.5
- octal
  3.4.1
- `OF_DEFAULT`
  2.1.2
- `OFFSET`
  2.2.2
- OMF
  8.4
- omitted parameters
  4.5.5
- OpenBSD
  8.11, 10.2
- operand-size prefixes
  3.1
- operands
  3.1
- operating system
  8.1
- operating system, writing
  11.1
- operators
  3.5
- operators, unary
  3.5.12
- `ORG`
  8.1.1, 9.2.1, 9.2.2, 13.1.3
- OS/2
  8.4, 8.4.1
- `osabi`
  8.9.1
- other preprocessor directives
  4.13
- out of range, jumps
  13.1.2
- output file format
  2.1.2
- output formats
  8
- overlapping segments
  3.6
- `OVERLAY`
  8.4.1
- overloading, multi-line macros
  4.5.1
- overloading, single-line macros
  4.2.1
- paradox
  3.8
- `PASCAL`
  9.5.3
- Pascal calling convention
  9.5.1
- period
  3.9
- PharLap
  8.4.1
- PIC
  8.9.3, 8.11, 10.2
- PLT
  8.9.3, 10.2.4, 10.2.5
- `PLT` relocations
  8.9.3, 10.2.4, 10.2.5
- plt relocations
  10.2.5
- pointer, elf attribute
  8.9.2
- position-independent code
  8.9.3, 8.11, 10.2
- pre-defining macros
  2.1.20, 4.2.1
- pre-including files
  2.1.19
- precedence
  3.5
- preferred
  3.6
- `preinit_array`
  8.9.2
- preprocess-only mode
  2.1.22
- preprocessor
  2.1.22, 2.1.23, 3.2.4, 3.5.11, 4
- preprocessor directives
  4.1.4, 4.1.6
- preprocessor functions
  4.1.6, 4.3, 4.4
- preprocessor, comment removal
  4.1.2
- preprocessor, conditionals
  4.1.4
- preprocessor, continuation line
  4.1.1
- preprocessor, expansions
  4.1
- preprocessor, expressions
  2.1.22
- preprocessor, loops
  4.1.4, 4.7
- preprocessor, variables
  4.2.8
- primitive directives
  7
- `PRIVATE`
  8.4.1
- `private_extern`
  8.8.5
- `proc`
  9.4.5, 10.1.4
- procedure linkage table
  8.9.3, 10.2.4, 10.2.5
- processor mode
  7.1
- `progbits`
  8.1.3, 8.9.2
- program entry point
  8.4.6, 9.1.1
- program origin
  8.1.1
- `protected`
  8.9.5
- pseudo-instructions
  3.2
- `PUBLIC`
  7.7, 8.4.1
- pure binary
  8.1
- quick start
  2.2
- `QWORD`
  3.1
- redirecting errors
  2.1.16
- `REL`
  3.3, 7.2.1
- release candidates
  E.1
- relocations, PIC-specific
  8.9.3
- removing contexts
  4.9.1
- renaming contexts
  4.9.5
- repeating
  3.2.5, 4.7
- reporting bugs
  E.2
- `REQUIRED`
  7.6
- `RESB`
  3.2, 3.2.2
- `RESD`
  3.2, 3.2.2
- `RESO`
  3.2, 3.2.2
- `RESQ`
  3.2, 3.2.2
- `REST`
  3.2, 3.2.2
- `RESW`
  3.2, 3.2.2
- `RESY`
  3.2, 3.2.2
- `RESZ`
  3.2, 3.2.2
- `{rex}`
  C.1.4
- rotating macro parameters
  4.5.8
- searching for include files
  4.8.1
- `SECTALIGN`
  5.10.2
- `SECTION`
  7.3
- section alignment, in `bin`
  8.1.2
- section alignment, in ELF
  8.9.2
- section alignment, in `obj`
  8.4.1
- section alignment, in `win32`
  8.5.1
- `SECTION`, ELF extensions to
  8.9.2
- `SECTION`, `macho` extensions to
  8.8.1
- `SECTION`, Windows extensions to
  8.5.1
- `SEG`
  3.6, 8.4
- `SEGMENT`
  7.3
- segment address
  3.5.12, 3.6
- segment alignment, in `bin`
  8.1.2
- segment alignment, in `obj`
  8.4.1
- segment names, Borland Pascal
  9.5.2
- `SEGMENT`, `obj` extensions to
  8.4.1
- segment override
  2.2.4, 3.1
- segments
  3.6
- segments, groups of
  8.4.2
- separator character
  2.1.35
- shared libraries
  8.11, 10.2
- `shift` command
  4.5.8
- signed, bit shift
  3.5.9
- signed, division
  3.5.11
- signed, modulo
  3.5.11
- single-line macros
  4.1.6, 4.2, A
- size, of symbols
  8.9.5
- `smartalign`
  6.2
- snapshots, daily development
  E.1
- Solaris x86
  8.9
- sound
  3.2.3
- source-listing file
  2.1.3
- square brackets
  2.2.2, 3.3
- `srec`
  8.3
- `STACK`
  8.4.1
- stack relative preprocessor directives
  4.10
- standard macro packages
  6
- standard macros
  5
- standardized section names
  7.3, 8.5.1, 8.9.2, 8.10, 8.11, 8.12
- `start=`
  8.1.3
- `STATIC`
  7.9
- `stderr`
  2.1.16
- `stdout`
  2.1.17
- `STRICT`
  3.7
- string
  3.4.2
- string, constants
  3.2.1, 3.4.2, 3.4.4
- string, length
  4.3.2
- string, manipulation in macros
  4.3
- strings, elf attribute
  8.9.2
- `strong`
  8.9.5
- `STRUC`
  5.9.1, 7.4, 9.4.4, 10.1.3
- structure data types
  5.9
- stub preprocessor
  2.1.23
- `subsections_via_symbols`
  8.8.3
- subtraction
  3.5.10
- suppressing preprocessing
  2.1.23
- switching between sections
  7.3
- symbols, exporting from DLLs
  8.4.5
- symbols, importing from DLLs
  8.4.4
- symbols, specifying sizes
  8.9.5
- symbols, specifying types
  8.9.5
- synchronization
  B.2.2
- tasm
  2.1.25, 2.2, 8.4
- `TBYTE`
  2.2.7
- `test` subdirectory
  9.1.1
- testing, arbitrary numeric expressions
  4.6.4
- testing, context stack
  4.6.3
- testing, exact text identity
  4.6.5
- testing, multi-line macro existence
  4.6.2
- testing, single-line macro existence
  4.6.1
- testing, token types
  4.6.6
- thread local storage, in ELF
  8.9.4
- thread local storage, in `macho`
  8.8.2
- `TIMES`
  3.2, 3.2.5, 3.8, 13.1.3, 13.1.4
- `TLINK`
  9.2.2
- tls
  8.8.2, 8.9.2, 8.9.4
- trailing colon
  3.1
- `TWORD`
  2.2.7, 3.1
- type, of symbols
  8.9.5
- unary operators
  3.5.12
- undefining macros
  2.1.21
- underscore, in C symbols
  9.4.1
- Unicode
  3.4.2, 3.4.5
- uninitialized
  3.2, 3.2.2
- uninitialized storage
  2.2.7, 3.2, 3.2.1
- Unix
- Unix, SCO
  8.9
- Unix, System V
  8.9
- UnixWare
  8.9
- unrolled loops
  3.2.5
- unsigned, bit shift
  3.5.9
- unsigned, division
  3.5.11
- unsigned, modulo
  3.5.11
- `UPPERCASE`
  2.2.1, 8.4.3
- `USE16`
  7.1.1, 8.4.1
- `USE32`
  7.1.1, 8.4.1
- user-defined errors
  4.11
- user-level directives
  5, 7
- UTF-8
  3.4.2
- UTF-16
  3.4.5
- UTF-32
  3.4.5
- VAL
  9.1.1
- valid characters
  3.1
- variable types
  2.2.3
- variables, preprocessor
  4.2.8
- version
  2.1.27
- version number of nasm
  5.1
- `vfollows=`
  8.1.3
- Visual C++
  8.5
- `vstart=`
  8.1.3
- `[WARNING]`
  2.1.26, 7.13
- warning class
  A
- warning class, `all`
  A
- warning class, `bad-pragma`
  A
- warning class, `bnd`
  A
- warning class, `db-empty`
  A
- warning class, `ea`
  A
- warning class, `ea-absolute`
  A
- warning class, `ea-dispsize`
  A
- warning class, `environment`
  A
- warning class, `float`
  A
- warning class, `float-denorm`
  A
- warning class, `float-overflow`
  A
- warning class, `float-toolong`
  A
- warning class, `float-underflow`
  A
- warning class, `forward`
  A
- warning class, `hle`
  A
- warning class, `label`
  A
- warning class, `label-orphan`
  A
- warning class, `label-redef`
  A
- warning class, `label-redef-late`
  A
- warning class, `lock`
  A
- warning class, `macro-def-case-single`
  A
- warning class, `macro-def-greedy-single`
  A
- warning class, `macro-def-param-single`
  A
- warning class, `macro-defaults`
  A
- warning class, `macro-params-legacy`
  A
- warning class, `macro-params-multi`
  A
- warning class, `macro-params-single`
  A
- warning class, `negative-rep`
  A
- warning class, `not-my-pragma`
  A
- warning class, `number-overflow`
  A
- warning class, `obsolete`
  A
- warning class, `obsolete-nop`
  A
- warning class, `obsolete-removed`
  A
- warning class, `obsolete-valid`
  A
- warning class, `orphan-labels`
  A
- warning class, `other`
  A
- warning class, `phase`
  A
- warning class, `pp`
  A
- warning class, `pp-else`
  A
- warning class, `pp-else-elif`
  A
- warning class, `pp-else-else`
  A
- warning class, `pp-empty-braces`
  A
- warning class, `pp-environment`
  A
- warning class, `pp-macro`
  A
- warning class, `pp-macro-def`
  A
- warning class, `pp-macro-def-case-single`
  A
- warning class, `pp-macro-def-greedy-single`
  A
- warning class, `pp-macro-def-param-single`
  A
- warning class, `pp-macro-defaults`
  A
- warning class, `pp-macro-params`
  A
- warning class, `pp-macro-params-legacy`
  A
- warning class, `pp-macro-params-multi`
  A
- warning class, `pp-macro-params-single`
  A
- warning class, `pp-macro-redef-multi`
  A
- warning class, `pp-open`
  A
- warning class, `pp-open-braces`
  A
- warning class, `pp-open-brackets`
  A
- warning class, `pp-open-string`
  A
- warning class, `pp-rep-negative`
  A
- warning class, `pp-sel-range`
  A
- warning class, `pp-trailing`
  A
- warning class, `pragma`
  A
- warning class, `pragma-bad`
  A
- warning class, `pragma-empty`
  A
- warning class, `pragma-na`
  A
- warning class, `pragma-unknown`
  A
- warning class, `prefix`
  A
- warning class, `prefix-bnd`
  A
- warning class, `prefix-hle`
  A
- warning class, `prefix-lock`
  A
- warning class, `prefix-lock-error`
  A
- warning class, `prefix-lock-xchg`
  A
- warning class, `prefix-opsize`
  A
- warning class, `prefix-seg`
  A
- warning class, `ptr`
  A
- warning class, `regsize`
  A
- warning class, `reloc`
  A
- warning class, `reloc-abs`
  A
- warning class, `reloc-abs-byte`
  A
- warning class, `reloc-abs-dword`
  A
- warning class, `reloc-abs-qword`
  A
- warning class, `reloc-abs-word`
  A
- warning class, `reloc-rel`
  A
- warning class, `reloc-rel-byte`
  A
- warning class, `reloc-rel-dword`
  A
- warning class, `reloc-rel-qword`
  A
- warning class, `reloc-rel-word`
  A
- warning class, `unknown-pragma`
  A
- warning class, `unknown-warning`
  A
- warning class, `user`
  A
- warning class, `warn-stack-empty`
  A
- warning class, `zeroing`
  A
- warning class, `zext-reloc`
  A
- warning classes, list
  A
- warnings
  2.1.26
- `weak`
  8.9.5, 8.9.6
- website
  E.1
- Win32
  8.4, 8.5, 10
- Win64
  8.6, 12
- Windows
  9.1
- Windows, debugging formats
  8.5.3
- `write`
  8.9.2
- writing operating systems
  11.1
- `WRT`
  3.6, 8.4, 8.8.2, 8.9.3, 8.9.4, 8.11
- `WRT ..got`
  10.2.3
- `WRT ..gotoff`
  10.2.2
- `WRT ..gotpc`
  10.2.1
- `WRT ..plt`
  10.2.5
- `WRT ..sym`
  10.2.4
- `www.delorie.com`
  9.1.1
- `www.pcorner.com`
  9.1.1
- `x2ftp.oulu.fi`
  9.1.1
- x32
  8.9